# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc商品包装已存在_商品包装新增,33,33-16,sit,be
主数据平台:后台运营系统商品包装新增接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_33st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取商品包装管理列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url1")
request_body = commonFuc().get_business_data(module, "payload1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
# 生成随机数
package_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取商品包装信息
productCode = result["data"]["list"][package_random]["productCode"]

# 第三步进行商品包装新增
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url16")
request_body = [
    {"rowEditStatus": None, "rowId": None, "productCode": productCode, "productId": None, "productName": None,
     "specifications": None, "measuringUnitName": None, "measuringUnit": None, "materialCode": "", "productParams": {},
     "boxQuantity": None, "boxLength": None, "boxWidth": None, "boxHeight": None, "boxVolume": None,
     "grossWeight": None, "totalTowedQuantity": None}]

"""

 场景: 商品包装已存在_商品包装新增
 用例名称：商品包装已存在_商品包装新增
 输出：{"success":false,"code":"ERROR","message":"%s等商品已维护，不可重复新增","data":null,"freshToken":null}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 将接口响应时间添加至result
result = json.loads(result.content)
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict16", productCode)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
