# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc库存客户清单批量导入验证,33,33-39,sit,be
主数据平台:后台运营系统库存客户清单批量导入接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import random
import json
import os


module = "cmdc_33st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers_file", cmdc_access_token)

# 第二步获取客户列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url36")
request_body = commonFuc().get_business_data(module, "payload36")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取随机数
customer_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取客户信息
customerCode = result["data"]["list"][customer_random]["customerCode"]
customerName = result["data"]["list"][customer_random]["customerName"]

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/库存客户清单导入模板.xlsx"

# 将客户信息写入文件中
excel = HandleExcel(file_path, "Sheet1")
excel.write_data(row=2, column=1, value=customerCode)
excel.write_data(row=2, column=2, value=customerName)


# 第三步进行批量导入
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url39")

# 获取文件
file = open(file_path, "rb")
files = {"file": file}

"""

 场景: 库存客户清单批量导入验证
 用例名称：库存客户清单批量导入验证
 输出：{"customerCode":"%s"}
"""

# 发送请求
result = requests.post(url, files=files, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取客户信息
result = json.loads(result.content)
# print(result)
result = {"customerCode": result["data"][0]["customerCode"]}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict39", customerCode)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
