# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc采购计划删除功能验证,33,33-31,sit,be
主数据平台:后台运营系统采购计划删除接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import random
import json

module = "cmdc_33st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取采购计划列表列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url29")
request_body = commonFuc().get_business_data(module, "payload29")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
procure_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取采购计划信息
id = result["data"]["list"][procure_random]["id"]

# 第二步对采购计划商品进行删除操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url31")
request_body = commonFuc().get_business_data(module, "payload31", id)
"""
 场景: 采购计划删除功能验证
 用例名称：采购计划删除功能验证
 输出：{"deleteSign":1}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db_be")

# 查询数据库中对应采购计划商品的删除标识
sql = "SELECT t.deleteSign FROM `cmdc-order`.tc_procure_product t WHERE id = {}".format(id)
result = {"deleteSign": mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict31")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

# 测试数据还原
# 更新数据库中对应采购计划商品的删除标识
sql = "UPDATE `cmdc-order`.tc_procure_product t SET t.deleteSign = 0 WHERE t.id = {}".format(id)
mysql_handle.executeUpdate(host, port, user, pwd, "cmdc-order", sql)
