# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc新增站点开放白名单,2299,2299-23,sit,bs
主数据平台:后台运营系统新增站点开放白名单接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import random
import json

module = "cmdc_area"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 查询数据库客户信息
sql = "SELECT t.userName FROM `cmdc-user`.cmdc_user t " \
      "WHERE companyId != 7 and userType = 2 and disableSign = 0 and deleteSign = 0 and platformStatus = 1 and status = 3"

# 生成随机数
user_random = random.randint(0, len(mysql_handle.selectSql(host, port, user, pwd, "cmdc-user", sql)) - 1)
# print(mysql_handle.selectSql(host, port, user, pwd, "cmdc-user", sql))
# 获取客户信息
account = mysql_handle.selectSql(host, port, user, pwd, "cmdc-user", sql)[user_random][0]

# 第二步新增站点白名单客户
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url23")
request_body = commonFuc().get_business_data(module, "payload23", account)
"""

 场景: 新增站点开放白名单
 用例名称：新增站点开放白名单
 输出：{"success":true,"code":"200","message":"添加成功","data":null,"freshToken":null}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 将接口响应时间添加至result
result = json.loads(result.content)
result["api_time"] = api_time

if result["success"]:
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict23")
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
else:
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict23_1")
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
