# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc站点开放白名单批量导入,2299,2299-27,sit,bs
主数据平台:后台运营系统白名单批量导入接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
from common.db.db import mySql
import requests
import random
import json
import os

module = "cmdc_area"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers_file", cmdc_access_token)

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/白名单导入模板.xlsx"

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 查询数据库客户信息
sql = "SELECT t.userName FROM `cmdc-user`.cmdc_user t " \
      "WHERE companyId != 7 and userType = 2 and disableSign = 0 and deleteSign = 0 and platformStatus = 1"

# 生成随机数
user_random = random.randint(0, len(mysql_handle.selectSql(host, port, user, pwd, "cmdc-user", sql)) - 1)
# 获取客户信息
userName = mysql_handle.selectSql(host, port, user, pwd, "cmdc-user", sql)[user_random][0]
iphone = "18700000000"
companyName = "白名单批量导入测试验证"
# print(userName)
# 将信息写入文件中
excel = HandleExcel(file_path, "Sheet1")
excel.write_data(row=2, column=1, value=userName)
excel.write_data(row=2, column=2, value=iphone)
excel.write_data(row=2, column=3, value=companyName)

# 第二步进行白名单批量导入
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url27")

# 获取文件
file = open(file_path, "rb")
files = {"file": file}

"""
 场景: 站点开放白名单批量导入
 用例名称：站点开放白名单批量导入
 输出：{"total":1}
"""

# 发送请求
result = requests.post(url, files=files, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)
# print(result)
if result["success"]:
    # 查询数据库客户信息
    sql = "SELECT count(t.siteOpenId) FROM `cmdc-user`.cmdc_siteopen t WHERE userName = '{}'".format(userName)
    result = {"total": mysql_handle.selectSql(host, port, user, pwd, "cmdc-user", sql)[0][0]}

    # 将接口响应时间添加到result
    result["api_time"] = api_time

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict27")
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
else:
    # 获取预期结果//白名单用户已存在
    check_dict = commonFuc().get_business_data(module, "checkDict24")
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)

# 删除测试数据
# 获取站点开放白名单列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url12")
request_body = commonFuc().get_business_data(module, "payload12")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取白名单信息
user_json = result["data"]["list"][0]

# 进行站点开放白名单删除
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url26")
request_body = user_json
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
