# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc宽限期批量新增功能验证,2298,2298-22,sit,bs
主数据平台:后台运营系统宽限期批量新增接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import datetime
import requests
import random
import json
import os

module = "cmdc_hospital"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers_file", cmdc_access_token)

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/经销商填报宽限期管理模板.xlsx"

# 第二步获取产品线信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url26_1")
# 发送请求
result = requests.get(url, headers=headers)
result = json.loads(result.content)

# 去除已下架的产品线
data = []
for i in result["data"]:
    if i["lineCodeDelete"]:
        continue
    else:
        data.append(i)
# 生成随机数
line_random = random.randint(1, len(data) - 1)
# 获取产品线信息
productLineCode = data[line_random]["productLineCode"]
productLineName = data[line_random]["productLineName"]

# 获取日期
now_date = datetime.datetime.now().strftime("%Y%m")
date = random.randint(1, 28)

# 将信息写入文件中
excel = HandleExcel(file_path, "Sheet1")
excel.write_data(row=2, column=1, value=productLineCode)
excel.write_data(row=2, column=2, value=productLineName)
excel.write_data(row=2, column=3, value=now_date)
excel.write_data(row=2, column=4, value=date)

# 第二步宽限期批量导入
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url29")
# 获取文件
file = open(file_path, "rb")
files = {"file": file}

"""

 场景: 宽限期批量新增功能验证
 用例名称：宽限期批量新增功能验证
 输出：{"success":true,"code":"200","message":"OK"}
"""

# 发送请求
result = requests.post(url, files=files, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 将接口响应时间添加至result
result = json.loads(result.content)
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict29")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

# 删除测试数据
# 获取宽限期管理列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url21")
request_body = commonFuc().get_business_data(module, "payload21")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取宽限期信息
id = result["data"]["list"][0]["id"]

# 进行宽限期删除操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url28")
request_body = [id]
# 发送请求
result = requests.post(url, json=request_body, headers=headers)


