# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc客户发放返利新增验证,2271,2271-33,sit,bs
主数据平台:运营后台管理系统客户发放返利新增接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
from datetime import timedelta, date
import requests
import json
import os
import random

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取返利规则列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url28_1")
request_body = commonFuc().get_business_data(module, "payload28_1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
print(result)
# 生成一个随机数字，用于后续随机选择某一条客户发放返利信息
rebate_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取返利规则信息
rebate_id = result["data"]["list"][rebate_random]["rebateid"]

# 第三步获取返利规则详情信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url23")
request_body = commonFuc().get_business_data(module, "payload23", rebate_id)
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
print(result)
# 获取规则对应的客户信息
customer_code = result["data"]["customerDataList"][random.randint(0, len(result["data"]["customerDataList"]) - 1)][
    "customercode"]

# 生成随机返利金额
amount = random.randint(1, 1000)

# 随机生成日期
start_date = date(2000, 1, 1)
end_date = date.today()


def random_date(start, end):
    delta = end - start
    random_days = random.randint(0, delta.days)
    return start + timedelta(days=random_days)


random_date = random_date(start_date, end_date)

# 第四步，进行客户发放返利新增
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url30")
request_body = commonFuc().get_business_data(module, "payload30", rebate_id, amount, customer_code)

"""
场景: 客户发放返利新增验证
用例名称：客户发放返利新增验证
输出：{"success":true,"code":"200"}
"""
# 发送请求
result = requests.post(url, json=request_body, headers=headers)

# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict30")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
