# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc根据公司id获取公司信息,2256,2256-13,sit,bs
主数据平台:后台运营系统根据公司id获取公司信息接口 
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_website"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username")
password = commonFuc().get_business_data(module, "password")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 第二步获取站点列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url4")
request_body = commonFuc().get_business_data(module, "payload4")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
website_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取站点信息
companyId = result["data"]["list"][website_random]["companyId"]

# 第三步根据站点信息获取站点信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url13")
request_body = commonFuc().get_business_data(module, "payload13", companyId)
"""

 场景: 根据公司id获取公司信息
 用例名称：根据公司id获取公司信息
 输出：{"companyId":"%s"}
"""

# 发送请求
result = requests.get(url, params=request_body)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取站点信息
result = json.loads(result.content)
# print(result)
result = {"companyId": result["data"]["companyId"]}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict13", companyId)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
